diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-phy.cc ns-3.36/src/lte/model/lte-ue-phy.cc
--- ns-3.35/src/lte/model/lte-ue-phy.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-phy.cc	2022-04-30 18:23:58.050734500 -0700
@@ -1375,6 +1375,10 @@
   m_a30CqiLast = Simulator::Now ();
   m_paLinear = 1;
 
+  m_rsReceivedPowerUpdated = false;
+  m_rsInterferencePowerUpdated = false;
+  m_dataInterferencePowerUpdated = false;
+
   m_packetBurstQueue.clear ();
   m_controlMessagesQueue.clear ();
   m_subChannelsForTransmissionQueue.clear ();
@@ -1441,6 +1445,18 @@
   SwitchToState (SYNCHRONIZED);
 }
 
+uint16_t
+LteUePhy::DoGetCellId ()
+{
+  return m_cellId;
+}
+
+uint32_t
+LteUePhy::DoGetDlEarfcn ()
+{
+  return m_dlEarfcn;
+}
+
 void
 LteUePhy::DoSetDlBandwidth (uint16_t dlBandwidth)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-phy.h ns-3.36/src/lte/model/lte-ue-phy.h
--- ns-3.35/src/lte/model/lte-ue-phy.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-phy.h	2022-04-30 18:23:58.050734500 -0700
@@ -507,7 +507,18 @@
    */
   void DoSynchronizeWithEnb (uint16_t cellId, uint32_t dlEarfcn);
   /**
-   * \brief Set DL bandwidth function
+   *
+   * Get cell ID
+   * \returns cell ID
+   */
+  uint16_t DoGetCellId ();
+  /**
+   * Get DL EARFCN
+   * \returns DL EARFCN
+   */
+  uint32_t DoGetDlEarfcn ();
+  /**
+   * Set DL bandwidth function
    *
    * \param dlBandwidth the DL bandwidth
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-phy-sap.h ns-3.36/src/lte/model/lte-ue-phy-sap.h
--- ns-3.35/src/lte/model/lte-ue-phy-sap.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-phy-sap.h	2022-04-30 18:23:58.050734500 -0700
@@ -44,7 +44,6 @@
    * \brief Send the MAC PDU to the channel
    *
    * \param p the MAC PDU to send
-   * \return true if
    */
   virtual void SendMacPdu (Ptr<Packet> p) = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-rrc.cc ns-3.36/src/lte/model/lte-ue-rrc.cc
--- ns-3.35/src/lte/model/lte-ue-rrc.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-rrc.cc	2022-04-30 18:23:58.050734500 -0700
@@ -114,15 +114,6 @@
   "CONNECTED_REESTABLISHING"
 };
 
-/**
- * \param s The UE RRC state.
- * \return The string representation of the given state.
- */
-static const std::string & ToString (LteUeRrc::State s)
-{
-  return g_ueRrcStateName[s];
-}
-
 
 /////////////////////////////
 // ue RRC methods
@@ -472,6 +463,20 @@
   return m_cellId;
 }
 
+bool
+LteUeRrc::IsServingCell (uint16_t cellId) const
+{
+  NS_LOG_FUNCTION (this);
+  for (auto &cphySap: m_cphySapProvider)
+    {
+      if (cellId == cphySap->GetCellId ())
+        {
+          return true;
+        }
+    }
+  return false;
+}
+
 
 uint8_t
 LteUeRrc::GetUlBandwidth () const
@@ -924,16 +929,10 @@
         {
           triggering = false; // report is triggered only when an event is on the primary carrier
           // in this case the measurement received is related to secondary carriers
-          // measurements related to secondary carriers are saved on a different portion of memory
-          SaveScellUeMeasurements (newMeasIt->m_cellId, newMeasIt->m_rsrp,
-                                   newMeasIt->m_rsrq, useLayer3Filtering,
-                                   params.m_componentCarrierId );
-        }
-      else
-        {
-          SaveUeMeasurements (newMeasIt->m_cellId, newMeasIt->m_rsrp,
-                              newMeasIt->m_rsrq, useLayer3Filtering);
         }
+      SaveUeMeasurements (newMeasIt->m_cellId, newMeasIt->m_rsrp,
+                          newMeasIt->m_rsrq, useLayer3Filtering,
+                          params.m_componentCarrierId);
     }
 
   if (m_state == IDLE_CELL_SEARCH)
@@ -1063,13 +1062,20 @@
           {
             NS_LOG_INFO ("haveMobilityControlInfo == true");
             SwitchToState (CONNECTED_HANDOVER);
+            if (m_radioLinkFailureDetected.IsRunning ())
+              {
+                ResetRlfParams ();
+              }
             const LteRrcSap::MobilityControlInfo& mci = msg.mobilityControlInfo;
             m_handoverStartTrace (m_imsi, m_cellId, m_rnti, mci.targetPhysCellId);
             //We should reset the MACs and PHYs for all the component carriers
-            for (uint16_t i = 0; i < m_numberOfComponentCarriers; i++)
+            for (auto cmacSapProvider: m_cmacSapProvider)
               {
-                m_cmacSapProvider.at (i)->Reset ();
-                m_cphySapProvider.at (i)->Reset ();
+                cmacSapProvider->Reset ();
+              }
+            for (auto cphySapProvider: m_cphySapProvider)
+              {
+                cphySapProvider->Reset ();
               }
             m_ccmRrcSapProvider->Reset ();
             StorePreviousCellId (m_cellId);
@@ -1345,11 +1351,16 @@
 {
   NS_LOG_FUNCTION (this);
 
-  m_sCellToAddModList = nonCec.sCellsToAddModList;
+  m_sCellToAddModList = nonCec.sCellToAddModList;
+
+  for (uint32_t sCellIndex: nonCec.sCellToReleaseList)
+    {
+      m_cphySapProvider.at (sCellIndex)->Reset ();
+      m_cmacSapProvider.at (sCellIndex)->Reset ();
+    }
 
-  for (std::list<LteRrcSap::SCellToAddMod>::iterator it = nonCec.sCellsToAddModList.begin (); it != nonCec.sCellsToAddModList.end (); it++)
+  for(auto &scell: nonCec.sCellToAddModList)
     {
-      LteRrcSap::SCellToAddMod scell = *it;
       uint8_t ccId = scell.sCellIndex;
 
 
@@ -1358,8 +1369,8 @@
       uint32_t ulEarfcn = scell.radioResourceConfigCommonSCell.ulConfiguration.ulFreqInfo.ulCarrierFreq;
       uint16_t dlBand = scell.radioResourceConfigCommonSCell.nonUlConfiguration.dlBandwidth;
       uint32_t dlEarfcn = scell.cellIdentification.dlCarrierFreq;
-      uint8_t txMode = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.antennaInfo.transmissionMode;
-      uint16_t srsIndex = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.soundingRsUlConfigDedicated.srsConfigIndex;
+      uint8_t txMode = scell.radioResourceConfigDedicatedSCell.physicalConfigDedicatedSCell.antennaInfo.transmissionMode;
+      uint16_t srsIndex = scell.radioResourceConfigDedicatedSCell.physicalConfigDedicatedSCell.soundingRsUlConfigDedicated.srsConfigIndex;
 
       m_cphySapProvider.at (ccId)->SynchronizeWithEnb (physCellId, dlEarfcn);
       m_cphySapProvider.at (ccId)->SetDlBandwidth (dlBand);
@@ -1369,7 +1380,7 @@
       m_cphySapProvider.at (ccId)->SetRnti (m_rnti);
       m_cmacSapProvider.at (ccId)->SetRnti (m_rnti);
       // update PdschConfigDedicated (i.e. P_A value)
-      LteRrcSap::PdschConfigDedicated pdschConfigDedicated = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.pdschConfigDedicated;
+      LteRrcSap::PdschConfigDedicated pdschConfigDedicated = scell.radioResourceConfigDedicatedSCell.physicalConfigDedicatedSCell.pdschConfigDedicated;
       double paDouble = LteRrcSap::ConvertPdschConfigDedicated2Double (pdschConfigDedicated);
       m_cphySapProvider.at (ccId)->SetPa (paDouble);
       m_cphySapProvider.at (ccId)->SetSrsConfigurationIndex (srsIndex);
@@ -1807,9 +1818,9 @@
 
 void
 LteUeRrc::SaveUeMeasurements (uint16_t cellId, double rsrp, double rsrq,
-                              bool useLayer3Filtering)
+                              bool useLayer3Filtering, uint8_t componentCarrierId)
 {
-  NS_LOG_FUNCTION (this << cellId << rsrp << rsrq << useLayer3Filtering);
+  NS_LOG_FUNCTION (this << cellId << +componentCarrierId << rsrp << rsrq << useLayer3Filtering);
 
   std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.find (cellId);
 
@@ -1844,6 +1855,8 @@
       MeasValues v;
       v.rsrp = rsrp;
       v.rsrq = rsrq;
+      v.carrierFreq = m_cphySapProvider.at (componentCarrierId)->GetDlEarfcn ();
+
       std::pair<uint16_t, MeasValues> val (cellId, v);
       std::pair<std::map<uint16_t, MeasValues>::iterator, bool>
       ret = m_storedMeasValues.insert (val);
@@ -1852,10 +1865,10 @@
     }
 
   NS_LOG_DEBUG (this << " IMSI " << m_imsi << " state " << ToString (m_state)
-                     << ", measured cell " << m_cellId
+                     << ", measured cell " << cellId
+                     << ", carrier component Id " << componentCarrierId
                      << ", new RSRP " << rsrp << " stored " << storedMeasIt->second.rsrp
                      << ", new RSRQ " << rsrq << " stored " << storedMeasIt->second.rsrq);
-  storedMeasIt->second.timestamp = Simulator::Now ();
 
 } // end of void SaveUeMeasurements
 
